#ifndef G

#ifdef NOLOG
#define LOG(s,t)
#endif

#define G

#include <stdio.h>
#include <ctype.h>

typedef char* Ptr;

#define LOR '|'
#define LAND '^'
#define LNEG '~'
#define LTRUE 'T'
#define LALL 'A'
#define PRED '.'
#define IMP ':'
#define IMP1 '-'
#define IMP2 '>'

#define Error( t ) { printf( "Error: %s\n", t ); }
#define isConst( s ) ( isdigit(*(s)) || *(s)=='"' )
#define isEconst( s ) ( *(s) == '#' )

#define isCon( s ) ( s==LOR || s==LAND || s==LNEG || s==IMP )
#define isLog( s ) ( isCon( s ) || s==LTRUE || s==LALL )
#define isRel( s ) ( s=='=' || s=='<' || s=='>' )
#define isRelPred( s ) ( isRel( s ) || s==LTRUE || s==PRED )

#define isBlank( s ) ( s=='\n' || s==9 || s ==' ' )
#define isAux( s ) ( s=='(' || s==')' || s=='[' || s==']' )
#define isDel0( s ) ( s==0 || s==',' || s==':' )
#define isPdel( s ) ( isDel0( s ) || isBlank( s ) || isAux( s ) \
		|| isCon( s ) || isRel( s ) )

#define isLB( s ) ( strncmp( s, "LB=", 3 )==0 )
#define isNEXT( s ) ( strncmp( s, "$O", 2 )==0 )
#define isIMP( s ) ( strncmp( s, "=>", 2 )==0 )
#define isIMP2( s ) ( strncmp( s, "->", 2 )==0 )

#define FUN

#define MOPROG 10240
#define MOLINE 2048
#define MOLABEL 30

#define wSTART 105
#define wSELECT 106
#define wSAVE 107
#define wASSUMPTION 108
#define wASKINV 109
#define wEXPAND 111
#define wPOST 112

#define wOK 1
#define wCANCEL 0

char sss[ 10240 ];

#endif
