#include "g.h"
#include "sentence.h"

typedef struct Sequent {
	FormulaListPtr formulaList1;
	FormulaListPtr formulaList2;
	char remark[ MOLABEL ];
} Sequent, *SequentPtr;

typedef struct SequentList {
	SequentPtr sequent;
	struct SequentList* sequentList;
} SequentList, *SequentListPtr;

extern SequentList sequentList;
extern SequentListPtr sequentListPtr;

extern FormulaListPtr FormulaListCopy();
extern int SetInclude();
extern FormulaListPtr SetRemove();
extern FormulaListPtr SetAdd();
extern int FormulaEqual();

extern SequentPtr NewSequent();
extern FormulaListPtr FormulaListAppend();

extern int ProcedureListPrint();
extern int AssumptionListPrint();
extern int SequentListPrint();
