#include "proof.h"

Sequent userAxiom;
SequentPtr userAxiomPtr = &userAxiom;
 

/*-------------------------------------------------------*/

FUN int SimplifySequentUseUserAxiom( s )
SequentPtr s;
{
	if (s==NULL) return( 1 );

	if ( SetSetInclude( userAxiomPtr->formulaList1, s->formulaList1 ) &&
		SetSetInclude( userAxiomPtr->formulaList2, s->formulaList2 )) {
			s->formulaList1 = NULL;
			s->formulaList2 = NULL;
			return;
	}
}


FUN int MakeUserAxiom( f )
FormulaPtr f;
{
	if (f->connective==IMP) {
        	userAxiomPtr->formulaList1 = 
			Formula2FormulaList( FormulaCopy( f->left ), LAND );
		if (isFalse( f->right )) userAxiomPtr->formulaList2 = NULL;
        	else userAxiomPtr->formulaList2 = 
			Formula2FormulaList( FormulaCopy( f->right ), LOR );
	} else {
        	userAxiomPtr->formulaList1 = NULL; 
        	userAxiomPtr->formulaList2 = 
			Formula2FormulaList( FormulaCopy( f ), LOR );
	}
}

FUN int wMakeUseAxiom( s2 )
char *s2;
{
	Formula f;

       	if (isInv( s2 )) AssertionRead( s2, &f );
	else FormulaRead( s2, &f );

	MakeUserAxiom( &f );
	SimplifySequentList( SimplifySequentUseUserAxiom );
}

