#include "proof.h"
 
FUN int SimplifySequentUsePremisses( s )
SequentPtr s;
{
	FormulaListPtr fl1, fl2;
	FormulaPtr p1;
	Formula p2;
        AssignList c;
        Assign c1;
	int k=0;

	if (s==NULL) return( 1 );

	/*R9*/
        fl2 = s->formulaList2;
        while( fl2 != NULL ) {
                p1  = fl2->formula;
                if (p1==NULL) {
                        fl2 = fl2->formulaList;
                        continue;
                }
 
                if ( p1->connective=='>') {
                        p2.left = p1->right;
                        p2.right = p1->left;
                        p2.connective = p1->connective;

                        if (SetInclude( &p2, fl2 )) {
                                s->formulaList2 =
                                        SetRemove( p1, s->formulaList2 );
                                s->formulaList2 =
                                        SetRemove( &p2, s->formulaList2 );
                                p1->connective = '=';
                                s->formulaList1 =
                                        SetAdd( p1, s->formulaList1 );
                        }
                }


                if (fl2!=NULL) fl2 = fl2->formulaList;
        }


	/*R10*/
	fl1 = s->formulaList1;
	while( fl1 != NULL ) {
		p1  = fl1->formula;
		if (isAssign1( p1 )) {
                        c1.termLeft = (TermPtr) p1->left;
                        c1.termRight = (TermPtr) p1->right;
                        c.assign = &c1;
                        c.assignList = NULL;
                        FormulaListSubstSim1( p1, s->formulaList1, &c );
                        FormulaListSubstSim( s->formulaList2, &c );

			if (TermNotInFunc( p1->left, p1->right))
                                s->formulaList1 = 
					SetRemove( p1, s->formulaList1 );

                }
		fl1 = fl1->formulaList;
	}
}

FUN int TermNotInFunc( x, y )
TermPtr x,y;
{
	char t11[ MOPROG ], t22[ MOPROG ];
	char *t1, *t2;
	int l;

/*
	if (x->type!=VAR ) return( 0 );
	if (!isNotConst( x->name )) return( 0 );
*/

	TermPrint( x, t11 );
	TermPrint( y, t22 );

	t1=t11;
	t2=t22;

	l = strlen( t1 );
	while (*t2) {
		if (strncmp( t1, t2,l )==0 && 
			isPdel( *(t2-1) ) &&
			isPdel( *(t2+l) ) ) {
			return( 0 );
		} else t2++;
	}
	return( 1 );
}




	





