#include "term.h"

FUN int SetInclude( e, s )
FormulaPtr e; FormulaListPtr s; 
{
        if (s==NULL) return( 0 );
	if (FormulaEqual(e,s->formula)) return( 1 );
	return( SetInclude( e, s->formulaList ));
}

FUN FormulaListPtr SetRemove( e, s )
FormulaPtr e; FormulaListPtr s;
{
        if (s==NULL) return( NULL );
	if (FormulaEqual(e,s->formula)) { return( s->formulaList ); } 
	s->formulaList = SetRemove( e, s->formulaList );
	return( s );
}

FUN FormulaListPtr SetAdd( e, s )
FormulaPtr e; FormulaListPtr s;
{
	FormulaListPtr p = (FormulaListPtr) calloc( sizeof( FormulaList ), 1 );
	p->formula = e;
	p->formulaList = s;
	return( p );
}

FUN int SetSetInclude( p, s )
FormulaListPtr p; FormulaListPtr s; 
{
	if (p==NULL) return( 1 );

	if (SetInclude( p->formula, s ))
		return( SetSetInclude( p->formulaList, s ));
	else return( 0 );
}

