#include "sentence.h"
extern int AssignRead();

FUN int SentElemRead( s1, s2 )
char *s1, *s2;
{
	int i=0;

	while( !(s1[i]==';' ) && s1[i] ) i++;
	s1[ i ] = 0;

	sp->sentence = (SentencePtr) calloc( sizeof( Sentence ), 1 );
	SentElemRead1( s1, s2, sp->sentence );

	sp->sentenceList = 
		(SentenceListPtr) calloc( sizeof( SentenceList ), 1 );
	sp = sp->sentenceList;
	return( i+1 );
}

FUN int SentElemRead1( ss, l, sent )
char* ss;
char *l;
SentencePtr sent;
{
	char l1[ MOLABEL ];
	char l2[ MOLABEL ];

	ss += LabelRead( ss, l1 );
	if (*ss == '=' && *(ss+1) == '>') ss += 2; else Error( "sent.elem" );

/*	ss += 1;  */
	sent->assignList = (AssignListPtr) 
		calloc( sizeof( AssignList ), 1 );
	ss += SentElemAssignReadList( ss, sent->assignList );

	if (*ss == '$' && *(ss+1) == 'O') { 
		ss += 2; 
		ss += LabelRead( ss, l2 );
	} else Error( "sent.elem, LB" );

	sent->type = ELEM;
	sprintf( sent->labels, "(%s,%s)", l1, l2 );
	strcpy( l, sent->labels );
}

FUN int SentElemAssignReadList( s, p )
char *s;
AssignListPtr p;
{
	char *ss=s;

	p->assign = (AssignPtr) calloc( sizeof( Assign ), 1 );

	if ( isNEXT( s ) && isLB( s+2 )) {
		AssignRead( "$Ox=x", p->assign );
		return( 0 );
	}

	ss += AssignRead( ss, p->assign );

	while (*ss=='^') {
		ss++;
		if ( isNEXT( ss ) && isLB( ss+2 )) return( ss-s );
		p->assignList = 
			(AssignListPtr) calloc( sizeof( AssignList ), 1 );
		p = p->assignList;
		p->assign = (AssignPtr) calloc( sizeof( Assign ), 1 );
		ss += AssignRead( ss, p->assign );
	}
	Error( "*** Missing $OLB ***" ); 
	return( ss-s );
}


/*---------------------------------------------------------------------*/

FUN int SentSeqComposition( s1, s2 )
char *s1, *s2;
{
        char t1[ MOLABEL ];
        char t2[ MOLABEL ];
        char t3[ MOLABEL ];
        char t4[ MOLABEL ];

        DivideLabels( s1, t1, t4 );
        DivideLabels( s2, t3, t2 );
        if (strcmp( t3,t4)) {
		/* Error( "sent.seq" ); */
		return( 0 );
	}

        sp->sentence = (SentencePtr) calloc( sizeof( Sentence ), 1 );
        sp->sentence->type = SEQ;
        sprintf( sp->sentence->labels, "(%s,%s)", t1, t2 );
        strcpy( sp->sentence->labels1, s1 );
        strcpy( sp->sentence->labels2, s2 );
        strcpy( s2, sp->sentence->labels );

        sp->sentenceList =
                (SentenceListPtr) calloc( sizeof( SentenceList ), 1 );
        sp = sp->sentenceList;

        return( 1 );
}


