#include "proof.h"
#include "w.h"

static int state1=0;
static char ss[ MOLABEL ];

void wAskInv( w, client_data, call_data )
Widget w;
XtPointer client_data, call_data;
{
	Widget tl = (Widget) client_data;
        ProcedureListPtr pl = &procedureList;
	SentenceListPtr pa;
	FormulaPtr p1;
	char s[ MOLINE ];

	state1 = 0;
	state = wASKINV;
        while( pl->procedure != NULL ) {
		if (pl->procedure->postCond==NULL) {
			state1 = 1;
			sprintf( s, "Please Provide the post-condition of %s:", 
				pl->procedure->name );
			strcpy( ss, pl->procedure->name );
			PopShell1( topLevel, wstart, s, "", "Ok", "Cancel" );
			return;
		} 
		if (pl->procedure->preCond==NULL) {
			state1 = 2;
			sprintf( s, "Please Provide the pre-condition of %s:", 
				pl->procedure->name );
			strcpy( ss, pl->procedure->name );
			PopShell1( topLevel, wstart, s, "", "Ok", "Cancel" );
			return;
		} 

		currentProcedure = pl->procedure;
		pa = pl->procedure->sentenceList;

		while (pa->sentenceList!=NULL) {
			if ( pa->sentence->type==LOOP ) {
				p1 = GetPostCond( pa->sentence->labels1 );
				if ( p1 == NULL ) {
					strcpy( ss, pa->sentence->labels1 );
					break;
				}
			} 
                	pa = pa->sentenceList;
                }
		if (pa->sentenceList!=NULL) {
			state1 = 3;
			sprintf( s, 
				"Please Provide the invariant of %s of procedure %s:", 
				pa->sentence->labels,
				pl->procedure->name );
			PopShell1( topLevel, wstart, s, "", "Ok", "Cancel" );
			return;
		}

                pl = pl->procedureList;
        }
	state = 0;
	StartProg0();
}


/*--------------------------------------------------*/

void wAskInvOk( i, w, client_data, call_data )
Widget w;
XtPointer client_data, call_data;
int i; 
{
	char s1[ MOPROG ];
	FILE *f;
	char *a;
	FormulaPtr p;

	if (i==wCANCEL) {
		state = 0;
		state1 = 0;
		popdown( wstart, wp1->pshell );

       	assumptionList.assumption = NULL;
        assumptionList.assumptionList = NULL;
        procedureList.procedure = NULL;
        procedureList.procedureList = NULL;
        currentProcedureList = &procedureList;
        wRedisplay( w, topLevel, call_data );

	XtVaSetValues( wstart, XtNlabel, "start",
    		XtNwidth, 80, XtNheight, 70, NULL );
	SetSensitiveFalse( FALSE );

		return;
	}

	if (!GetInput( s1, wp1->text )) return;

	state = 0;
	popdown( wstart, wp1->pshell );

	p = (FormulaPtr) calloc( sizeof( Formula ), 1 );
	if (isInv( s1 )) AssertionRead( s1, p );
	else FormulaRead( s1, p );
	if (state1==1) AddPostCond( ss, p );
	if (state1==2) AddPreCond( ss, p ); 
	if (state1==3) AddPostCond( ss, p ); 

	wAskInv( w, client_data, call_data );
} 

