#include "w.h"

PopupBox popupBoxes[ 100 ];
int numberOfBoxes = -1;

int CreateReadBox()
{
	PopupBoxPtr p;
	numberOfBoxes++;
	p = &popupBoxes[ numberOfBoxes ];

        p->pshell = XtVaCreatePopupShell(
                "pshell",
                transientShellWidgetClass,
                topLevel,
		XtNheight, 470,
		NULL );

	p->box = XtVaCreateManagedWidget(
		"box",
		boxWidgetClass,
		p->pshell,
		NULL);
	p->label = XtVaCreateManagedWidget(
		"label",
		labelWidgetClass,
		p->box,
		XtNwidth, 500, XtNheight, 30,
		XtNx, 100, XtNy, 100,
		XtNborderWidth, 0,
		NULL);
	p->text = XtVaCreateManagedWidget(
		"text",
		asciiTextWidgetClass,
		p->box,
		XtNstring, "",
		XtNtype,XawAsciiString,
		XtNeditType, XawtextEdit,
		XtNwidth, 500, XtNheight, 400,
		XtNautoFill, TRUE,
		XtNscrollVertical, XawtextScrollWhenNeeded,
		XtNscrollHorizontal, XawtextScrollWhenNeeded,
		NULL);
        p->ok = XtVaCreateManagedWidget(
                "ok",
                commandWidgetClass,
                p->box,
		XtNlabel, "Ok",
		XtNwidth, 246, XtNheight, 30,
		XtNresize, FALSE,
                NULL );
        p->cancel = XtVaCreateManagedWidget(
                "cancel",
                commandWidgetClass,
                p->box,
		XtNlabel, "Cancel",
		XtNwidth, 246, XtNheight, 30,
		XtNresize, FALSE,
                NULL );

        XtAddCallback( p->ok, XtNcallback, DialogDone, p->box );
        XtAddCallback( p->cancel, XtNcallback, Cancel, p->box );

	return( numberOfBoxes );
}


int CreateListBox()
{
	PopupBoxPtr p;
	numberOfBoxes++;
	p = &popupBoxes[ numberOfBoxes ];


        p->pshell = XtVaCreatePopupShell(
                "pshell2",
                transientShellWidgetClass,
                topLevel,
		XtNheight, 515,
		NULL );

        p->box = XtVaCreateManagedWidget(
                "box2",
                boxWidgetClass,
                p->pshell,
                NULL );
        p->label = XtVaCreateManagedWidget(
                "label",
                labelWidgetClass,
                p->box,
		XtNwidth, 300, XtNheight, 30,
                NULL );
	p->text = XtVaCreateManagedWidget(
		"text",
		asciiTextWidgetClass,
		p->box,
		XtNstring, "",
		XtNtype,XawAsciiString,
		XtNeditType, XawtextRead,
		XtNwidth, 300, XtNheight, 450,
		XtNautoFill, TRUE,
		XtNscrollVertical, XawtextScrollWhenNeeded,
		XtNselectTypes, a,
		NULL);
        p->ok = XtVaCreateManagedWidget(
                "expand",
                commandWidgetClass,
                p->box,
		XtNlabel, "Expand",
		XtNwidth, 146, XtNheight, 30,
		XtNresize, FALSE,
                NULL );
        p->cancel = XtVaCreateManagedWidget(
                "cancel",
                commandWidgetClass,
                p->box,
		XtNlabel, "Cancel",
		XtNwidth, 146, XtNheight, 30,
		XtNresize, FALSE,
                NULL );

        XtAddCallback( p->ok, XtNcallback, DialogDone, p->box );
        XtAddCallback( p->cancel, XtNcallback, Cancel, p->box );

	return( numberOfBoxes );
}

