#include "w.h"

main( argc, argv )
int argc; char **argv;
{ 
	XtAppContext app_context;
	Widget box;
	char *a;

	topLevel = XtVaAppInitialize(
		&app_context,
		"XBox1",
		NULL, 0,
		&argc, argv,
		NULL, 
		NULL);

	CreateMainBox(); 

	wInit( argc, argv );

	XtAddCallback( wquit, XtNcallback, wQuit, 0 );
	XtAddCallback( wclear, XtNcallback, wClear, topLevel );
	XtAddCallback( wstart, XtNcallback, wStart, topLevel );
	XtAddCallback( wsave, XtNcallback, wSave, topLevel );
	XtAddCallback( wassumption, XtNcallback, wAssumption, topLevel );
	XtAddCallback( wselect, XtNcallback, wSelect, topLevel );
	XtAddCallback( wredisplay, XtNcallback, wRedisplay, topLevel );
	XtAddCallback( wpost, XtNcallback, wPost, topLevel );
	XtAddCallback( wexpand, XtNcallback, wExpand, topLevel );

	XtVaSetValues( topLevel, XtNx, 50, XtNy, 100, NULL );
	XtRealizeWidget( topLevel );

	if (argc>1) {
		if (strcmp( argv[ 1 ], "-d" )) {
        		StartProg1( argv[ 1 ] );
        		a = wGetProcList();
        		XtVaSetValues( wtext, XtNstring, a, NULL );
			XtVaSetValues( wstart, XtNlabel, "add-proc",
    				XtNwidth, 80, XtNheight, 70, NULL );
        		wAskInv( topLevel, topLevel, NULL );

			if (argc==3 && state==0) {
				wFileWrite( argv[ 2 ] );
				exit( 0 );
			}
		} else { 
			LogFileOpen();
			SetSensitiveFalse( FALSE );
		}
	} else SetSensitiveFalse( FALSE );

	XtAppMainLoop( app_context );

}

SetSensitiveFalse( k )
int k;
{
	XtSetSensitive( wclear, k );
	XtSetSensitive( wsave, k );
	XtSetSensitive( wassumption, k );
	XtSetSensitive( wselect, k );
	XtSetSensitive( wredisplay, k );
	XtSetSensitive( wpost, k );
	XtSetSensitive( wexpand, k );
}
