#include "sentence.h"

FUN int SentCallRead( s1, s2 )
char *s1, *s2;
{
	int i=0;
	int j = 0;

	while( s1[i] && ( s1[i]!=';' || j!=0 )) {
		if ( s1[i] == '(' ) j++;
		else if ( s1[i] == ')' ) j--;
		i++;
	}

	s1[ i ] = 0;


        sp->sentence = (SentencePtr) calloc( sizeof( Sentence ), 1 );
        SentCallRead1( s1, s2, sp->sentence );
 
        sp->sentenceList =
                (SentenceListPtr) calloc( sizeof( SentenceList ), 1 );
        sp = sp->sentenceList;
        return( i+1 );
}

FUN int SentCallRead1( s, s2, sent )
char *s;
char *s2;
SentencePtr sent;
{
	char l1[ MOLABEL ];
	char l2[ MOLABEL ];
	char *pname = sent->labels1;;

	if ( isLB( s ) ) s += LabelRead( s, l1 );
	if ( isIMP( s ) ) s += 2; else Error( "sent.call" );
	while ( *s != '(' ) *pname++ = *s++;
	*pname = 0;

	sent->assignList = 
                (AssignListPtr) calloc( sizeof( AssignList ), 1 );
	s += SentCallAssignList( s, sent->assignList );


	if (*s == '^' ) { s += 1; }
	if ( isNEXT( s ) ) { s += 2; } else Error( "sent.call" );
	if ( isLB( s ) ) s += LabelRead( s, l2 );

        sprintf( sent->labels, "(%s,%s)", l1, l2 );
	sent->type = CALL;
        strcpy( s2, sent->labels );

	return( 0 );
}

FUN int SentCallAssignList( ss, tp )
char *ss;
AssignListPtr tp;
{
	char l1[ MOLINE ];
	char l2[ MOLINE ];
	char l3[ MOLINE ];
	char *s1, *s2, *s3;
	char *s=ss;

	s3 = l3;

	if (*ss == '(') { ss++; }
	if (*ss==')') { ss++; return( ss-s ); }

	while( 1 ) {
		ss += ReadTo( ss, l1, '/', '/' ) + 1;

		if (strcmp( l1, "%IOP")==0) {
			ss += ReadTo( ss, l1, '/', '|' ) + 1;
			ss += ReadTo( ss, l2, ';', ')' );
		} else if (strcmp( l1, "%INP")==0) {
			ss += ReadTo( ss, l1, '/', '|' ) + 1;
			ss += ReadTo( ss, l2, ';', ')' );
		}
		sprintf( s3, "^$O%s=%s", l2, l1 );
		s3 += strlen( s3 );
		if (*ss==')') break; else ss++;
		
	}

	ss++;

	AssignReadList( l3+1, tp );
	AssignListPrint( tp, l3 );

	return( ss-s );
}
