#include "sentence.h"

FUN int SentLoopRead( s, l )
char *s;
char *l;
{
	int i, j, k;

	i = 2; j = 1;
	while( s[ i ] && j ) {
		if ( s[ i ] == '[' ) j++;
		if ( s[ i ] == ']' ) j--;
		i++;
	}

	s += 2;
	k = 0;
/*	while( s[ k++ ] != ';' );
*/
	while (!( s[ k ] == '=' && s[ k+1 ] == '>' )) k++;
	while( s[ k++ ] != '(' );
	
	j=1;
	while( s[ k ] && j ) {
		if ( s[ k ] == '(' ) j++;
		if ( s[ k ] == ')' ) j--;
		k++;
	}

	SentenceRead( s+k, l );

        sp->sentence = (SentencePtr) calloc( sizeof( Sentence ), 1 );
	SentLoopRead1( s, l, sp->sentence );

        sp->sentenceList =
                (SentenceListPtr) calloc( sizeof( SentenceList ), 1 );
        sp = sp->sentenceList;

	return( i );
}

FUN int SentLoopRead1( s, l, sent )
char *s; char *l;
SentencePtr sent;
{
	char l1[ MOLABEL ];
	char l2[ MOLABEL ];
	char l3[ MOLABEL ];

	sent->cond = (FormulaPtr) calloc( sizeof( Formula ), 1 );
	if ( isLB( s ) ) s += LabelRead( s, l1 );
	else Error( "loop" );
	if ( *s == '^' ) s += 1 + SentCondRead( s+1, sent->cond );
	else Error( "loop" );
	if ( *s == '(' ) s += 1; 
	else Error( "loop" );
	if ( isNEXT( s ) )  s += 2; 
	else Error( "loop" );
	if ( isLB( s ) ) s += LabelRead( s, l2 ); 
	else Error( "loop" );
	if ( *s == '|' ) s += 1; 
	else Error( "loop" );
	if ( isNEXT( s ) ) s += 2; 
	else Error( "loop" );
	if ( isLB( s ) ) s += LabelRead( s, l3 ); 
	else Error( "loop" );
	if ( *s == ')' ) s += 1;
	else Error( "loop" );

	sent->type = LOOP;
	sprintf( sent->labels, "(%s,%s)", l1, l3 );
	sprintf( sent->labels1, "(%s,%s)", l2, l1 );
	strcpy( l, sent->labels );
}

FUN int SentCondRead( s, p )
char *s;
FormulaPtr p;
{
	int i=0;

	while( !(s[i]=='=' && s[i+1]=='>') && s[i] ) i++;
	s[ i ] = 0;
	s[ i+1 ] = 0;
	FormulaRead( s, p );

	return( i+2 );
}

/*------------------------------------------------------------------*/


FUN int SentCaseRead( s, l )
char *s;
char *l;
{
        int i, j;
 
 
        i = 2; j = 1;
        while( s[ i ] && j ) {
                if ( s[ i ] == '[' ) j++;
                if ( s[ i ] == ']' ) j--;
                i++;
        }
 
        s += 2;
        j = 0;
        while( s[ j++ ] != ';' );
 
        SentenceRead( s+j, l );

        sp->sentence = (SentencePtr) calloc( sizeof( Sentence ), 1 );
        SentCaseRead1( s, l, sp->sentence );

        sp->sentenceList =
                (SentenceListPtr) calloc( sizeof( SentenceList ), 1 );
        sp = sp->sentenceList;
 
        return( i );
}
 
FUN int SentCaseRead1( s, l, sent )
char *s; char *l;
SentencePtr sent;
{
        char l1[ MOLABEL ];
        char l2[ MOLABEL ];
        char l3[ MOLABEL ];
        char l4[ MOLABEL ];
        char l5[ MOLABEL ];
 
	sent->cond = (FormulaPtr) calloc( sizeof( Formula ), 1 );
	if ( isLB( s ) ) s += LabelRead( s, l1 );
	else Error( "case1" );
        if ( *s == '^' ) s += 1 + SentCondRead( s+1, sent->cond );
	else Error( "case2" );
        if ( isNEXT( s ) ) s += 2;
	else Error( "case3" );
	if ( isLB( s ) ) s += LabelRead( s, l2 );
	else Error( "case4" );
        if ( *s == '|' ) s += 1;
	else Error( "case5" );
        if ( *s == '~' ) s += 1; 
	else Error( "case6" );
        if ( isIMP( s ) ) s += 2;
	else Error( "case7" );
        if ( isNEXT( s ) ) s += 2;
	else Error( "case8" );
	if ( isLB( s ) ) s += LabelRead( s, l3 );
	else Error( "case9" );
        if ( *s == ';' ) s += 1;
	else Error( "case10" );
 
        DivideLabels( l, l4, l5 );
	sent->type = COND;
        sprintf( sent->labels, "(%s,%s)", l1, l5 );
        sprintf( sent->labels1, "(%s,%s)", l2, l5 );
        sprintf( sent->labels2, "(%s,%s)", l3, l5 );
        strcpy( l, sent->labels );
}

