#include "term.h"

/*------------------------------------------------------------------*/

FUN int AssignRead( s, t )
char* s;
AssignPtr t;
{
	char *ss=s;

	if ( isNEXT( ss ) ) ss += 2; 
	else Error( "*** Missing $O ***" ); 

	t->termLeft = (TermPtr) calloc( sizeof( Term ), 1 );
	ss += TermRead( ss, t->termLeft );
	if ( *ss=='=' ) ss++ ; else Error( "*** Missing = ***" ); 
	t->termRight = (TermPtr) calloc( sizeof( Term ), 1 );
	ss += TermRead( ss, t->termRight );

	return( ss-s );
}

FUN int AssignReadList( s, p )
char *s;
AssignListPtr p;
{
        char *ss=s;

        p->assign = (AssignPtr) calloc( sizeof( Assign ), 1 );
        ss += AssignRead( ss, p->assign );
        while (*ss=='^') {
                ss++;
                p->assignList =
                        (AssignListPtr) calloc( sizeof( AssignList ), 1 );
                p = p->assignList;
                p->assign = (AssignPtr) calloc( sizeof( Assign ), 1 );
                ss += AssignRead( ss, p->assign );
        }
        return( ss-s );
}
 
/*----------------------------------------------------------------*/

FUN AssignPrint( t, s )
AssignPtr t; char *s;
{
	sprintf( s, "$O" );
	TermPrint( t->termLeft, s+2 );
	s += strlen( s );
	sprintf( s, "=" );
	TermPrint( t->termRight, s+1 );
}

FUN AssignListPrint( t, s )
AssignListPtr t; char *s;
{
	if ( t==NULL ) { *s=0; return( 0 ); }

	AssignPrint( t->assign, s );

	if ( t->assignList == NULL ) return( NULL );
	s += strlen( s );
	sprintf( s, "^" );
	AssignListPrint( t->assignList, s+1 );
}

