#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/AsciiText.h>
#include "g.h"

typedef struct { String string; int index; } *XtListReturnStruct;

/*
#define dialog1t1 "Please enter an elementary sentence:"
#define dialog1t2 "Please enter the post-condition:"
#define dialog2t1 "Select a block:"
#define dialog2t2 "Select the other block:"
#define dialog3t1 "Enter an entrance label:"
#define dialog3t2 "Enter a selection condition:"
#define dialog3t3 "Select a block:"
#define dialog3t4 "Select the other block:"
#define dialog4t1 "Enter a loop condition:"
#define dialog4t2 "Select a block:"
#define dialog4t3 "Enter an exit label:"
#define dialog5t1 "Select a block:"
#define dialog6t1 "Assumptions:"
*/

extern XawTextSelectType a[3];
extern XawTextBlock textString;

typedef struct PopupBox {
	Widget pshell, box; 
	Widget label, text, ok, cancel, expand;
	Widget prog, prepost, assump;
} PopupBox, *PopupBoxPtr;

extern Widget topLevel;
extern Widget wquit, wsave, wstart, wclear, wassumption, wselect;
extern Widget wredisplay, wpost, wexpand;
extern Widget wtext;

extern PopupBox popupBoxes[ 100 ];
extern int numberOfBoxes;
extern PopupBoxPtr wp1, wp2, wp3;
 
extern int state;

extern void DialogDone(); 
extern void Cancel();
extern void Expand(); 

extern void wQuit();
extern void wAssumption();
extern void wSelect();
extern void wStart();
extern void wSave();
extern void wClear();
extern void wRedisplay();
extern void wPost();
extern void wExpand();

extern void *wCompressString(); 
extern char *wGetProcList();
extern char *wGetAssumptionList();
extern char *wGetAssumptionList2();
extern char *wGetProcPrePostCond();
extern char *wGetSentPrePostCond();
extern char *wGetProcContent();
extern char *wGetProcContent2();
extern char *wGetSentenceContent();
extern char *wGetSentenceContent2();
extern char *wGetSentenceList();
